VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2220
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2175
   LinkTopic       =   "Form1"
   ScaleHeight     =   2220
   ScaleWidth      =   2175
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Height          =   1935
      Left            =   120
      ScaleHeight     =   1875
      ScaleWidth      =   1875
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, lpPoint As Long) As Long
Private Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Const SRCCOPY = &HCC0020
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long
Private Const BLACK_PEN = 7
Private Const WHITE_BRUSH = 0
Private Const NULL_BRUSH = 5
Private Declare Function Rectangle Lib "gdi32" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
' **********
Private Type MemoryBitmap
    hDC As Long
    hBM As Long
    oldhDC As Long
    wid As Long
    hgt As Long
End Type
' Delete the bitmap and free its resources.
Private Sub DeleteMemoryBitmap(memory_bitmap As MemoryBitmap)
    SelectObject memory_bitmap.hDC, memory_bitmap.oldhDC
    DeleteObject memory_bitmap.hBM
    DeleteDC memory_bitmap.hDC
End Sub

' Draw on the memory bitmap.
Private Sub DrawOnMemoryBitmap(memory_bitmap As MemoryBitmap)
Dim wid As Long
Dim hgt As Long

    wid = memory_bitmap.wid
    hgt = memory_bitmap.hgt

    ' Give the device context a white background.
    SelectObject memory_bitmap.hDC, GetStockObject(WHITE_BRUSH)
    Rectangle memory_bitmap.hDC, 0, 0, wid, hgt
    SelectObject memory_bitmap.hDC, GetStockObject(NULL_BRUSH)

    ' Draw the on the device context.
    SelectObject memory_bitmap.hDC, GetStockObject(BLACK_PEN)
    MoveToEx memory_bitmap.hDC, 0, 0, ByVal 0&
    LineTo memory_bitmap.hDC, wid, hgt
    MoveToEx memory_bitmap.hDC, 0, hgt, ByVal 0&
    LineTo memory_bitmap.hDC, wid, 0
End Sub
' Make a memory bitmap of the given size.
' Return the bitmap's DC.
Private Function MakeMemoryBitmap(ByVal wid As Long, ByVal hgt As Long) As MemoryBitmap
Dim result As MemoryBitmap

    ' Create the device context.
    result.hDC = CreateCompatibleDC(0)

    ' Create the bitmap.
    result.hBM = CreateCompatibleBitmap( _
        result.hDC, wid, hgt)

    ' Make the device context use the bitmap.
    result.oldhDC = SelectObject(result.hDC, result.hBM)

    ' Return the MemoryBitmap structure.
    result.wid = wid
    result.hgt = hgt
    MakeMemoryBitmap = result
End Function
Private Sub Form_Load()
Dim memory_bitmap As MemoryBitmap

    ' Create the memory bitmap.
    Picture1.ScaleMode = vbPixels
    memory_bitmap = MakeMemoryBitmap( _
        Picture1.ScaleWidth, _
        Picture1.ScaleHeight)

    ' Draw on the bitmap.
    DrawOnMemoryBitmap memory_bitmap

    ' Copy the device context into the PictureBox.
    Picture1.AutoRedraw = True
    BitBlt Picture1.hDC, 0, 0, _
        Picture1.ScaleWidth, _
        Picture1.ScaleHeight, _
        memory_bitmap.hDC, 0, 0, SRCCOPY
    Picture1.Picture = Picture1.Image

    ' Delete the memory bitmap.
    DeleteMemoryBitmap memory_bitmap
End Sub
